from socket import *
from select import *
import json

srv = socket(AF_INET, SOCK_STREAM)
srv.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
srv.bind(("0.0.0.0", 5555))
srv.listen()

sockets = [srv]

projs = {"A" : 3, "B" : 6, "C" : 5}
projs_max = {"A" : 5, "B" : 10, "C" : 5}
ips = { }

manager = None

while True:
     readable, _, _ = select(sockets, [], [], 1)
     for active in readable:
        if active == srv:
            cli, addr = srv.accept()
            ips[cli] = addr[0]
            print("New client: ", addr)
            sockets.append(cli)
        else:
            msg = active.recv(1000)
            if msg:
                msg = msg.decode()
                if "LISTA" in msg:
                    reply = json.dumps(projs)
                    active.send(reply.encode())

                elif "JELENTKEZEK" in msg:
                    _ , name = msg.split(":")
                    if projs[name] < projs_max[name]:
                        print("uj jelentkezo")
                        mgr_msg = ips[active]+":"+name+":"+str(projs[name])
                        manager.send(mgr_msg.encode())
                        mgr_reply = manager.recv(10000)
                        mgr_reply = mgr_reply.decode()
                        if "IGEN" in mgr_reply:
                            active.send(b"OK")
                            projs[name] += 1
                        else:
                            active.send(b"ELUTASITVA")
                    else:
                        active.send(b"HIBA")

                elif "TITKOS" in msg:
                    manager = active
                    active.send(b"OK")
                
                elif "HOZZAAD" in msg:
                    if active != manager:
                        active.send(b"HIBA")
                    else:
                        _, name, num = msg.split(":")
                        projs[name] = 0
                        projs_max[name] = int(num)
                        active.send(b"PROJEKT HOZZAADVA")

                else:
                    active.send(b"ROSSZ PARANCS")

            else:
                print("Client left")
                active.close()
                sockets.remove(active)
